dbDeveloper - Database Editing/Administration Tool for multiple databases (Oracle, DB2, Sybase, Microsoft SQL Server, PostgreSQL, MySQL, Firebird)

Overview

dbDeveloper is a visual development tool for multiple databases exploration, design, creation and modification in an easy and powerful way. It allows you to view or change structure of every database using the same interface. It supports most popular database systems and allows to use the same interface in each of them, making work faster and more efficient.

With this tool you can browse and change any database object, issue SQL commands etc. in the same way. Moreover dbDeveloper supports special features for every database server.

At low purchase costs dbDeveloper can enhance your business processes through unifying development and administration features in one tool. Initial training, installation, maintenance and support are all cost factors reduced due to the uniform concept of dbDeveloper.
Designed for DBA's and developers, it can also make life easier for the end user thanks to its easy-to-use graphical user interface.

It is designed to work with any database.
Moreover it has a support (field types, execution plans, special functions, procedures and function listing, etc.) for following databases:
  • Oracle
  • MS SQL Server
  • Sybase
  • DB2
  • Interbase
  • Firebird
  • MySQL
  • PostgreSQL
  • MaxDB
  • Advantage Database Server
It also supports MS Access, DBF and Paradox (using ODBC or BDE)


Features

Developer
  • Supports most of popular databases. Contrary to majority of database tools, it is not dedicated to only one database. It can work with different data types, functions, procedures, etc. unique for used database server.
  • Easy to use. It doesn't need any training. Its object-oriented interface takes you to any database function within a few clicks.
  • Shows Tables, Sequences, Views and detailed information for all of them.
  • Display all table indexes, constraints, references etc.
  • Users can display, update, delete or insert colums, rows, indexes and constraints.
  • Integrated SQL editor shows syntax through color coding and allows the user to create professional-looking code. You can run the statement and see the results below. Code competition, text replacing, multilevel undo etc. make this a professional SQL editor.
  • Multiwindowed SQL editor. You can add or remove files with sql statements and work with them simultaneously.
  • SQL statements History.
  • Displays procedures, functions, packages, triggers, java sources etc. Coloured syntax and many functions from SQL editor makes it easy to find the object of our interest.
  • Editing and compiling pocedures, functions, triggers, packages, etc.
  • Executing and testing pocedures and functions (input and output params values).
  • Parametrized SQL queries
  • SQL code formater.
  • SQL Completion proposal (tables, columns for tables and aliases, procedures, triggers, ...)
  • In-grid result data edition (tables window)
  • Copy DDL to clipboard (create statements, insert statements, update statements, select statements)
  • Simple and useful results filtering and sorting function.
  • Transactions
Administrator
  • You can view, delete or turncate tables.
  • dbDeveloper shows all users existing in the system.
  • You can view general information of all database devices installed in the system.
  • Shows all system objects (tables, views, sequences, indexes, constraints, etc.)
  • In Oracle dbDeveloper can display all sessions and their current status and system locks. Database administrator can kill sessions.
  • Execution plan for Oracle, SQLServer and MySQL (DB2 soon).
  • Tablespaces, DBLinks, Jobs, Clusters, Directories, Exceptions, etc. (databases special features)
Others
  • Multi-document interface techniques lets us work with many open windows in any time. You can watch more than one window at one time. For example, you can edit an SQL statement in one window while looking at table columns in another.
  • Export results data to HTML, XML, CSV text files. Also export as 'insert into...' statements.
  • Direct or ODBC or BDE (user choice) database connections.
  • Interface skins support.


Feature table

This table contains the key features of dbDeveloper.
If you are missing a feature or if you have any other suggestions, please do not hesitate to contact us.

Implemented In progress Planned Not available


Usage

Shortcuts

Below you can find useful program shortcuts.

Connections window F2
Next window Ctrl+Tab
Previous window Ctrl+Shift+Tab

Execute SQL Statement (active block or selected text)Ctrl+E or F5
Execution plan for SQL Statement (active block or selected text)Ctrl+Shift+E
Select all Ctrl+A
Select active block Ctrl+Shift+A
Next SQL file Ctrl+2
Previous SQL file Ctrl+1
Paste SQL statement with new line formating ('\n' breaks the line) Shift+Ins


FAQ

Frequently Asked Questions

General questions
1. What is dbDeveloper?
2. Where can I obtain a dbDeveloper?
3. What is the trial period of dbDeveloper and what functionality limitations does the trial version have?
4. How can I purchase dbDeveloper?
5. What support is available for dbDeveloper?
6. What platform does dbDeveloper run on?

Technical questions
1. How can I sort using two or more columns?
2. What expressions can be used to filter data id grid?
3. Sometimes specyfying alias or (table name) and dot I should get Completion Proposal with list of table columns. But instead I get a list of tables?
4. When I'm in Connect dialog and choose Oracle I got an error "TNS ....". My Oracle configuration is correct because I can connect to server using SQL Plus?
5. I connect through ODBC. During calling some queries I got an error: "Invalid descriptor index <13>
6. What are minimum required files for connect to MS SQL Server?
7. How I can connect to SQL Anywhere(or Adaptive Server Anywhere) using SQLDirect Components?
8. What’s need for Open Client Library deploy?
9. How can I connect to specified server. What connection string should I put in the "Services" field?

General questions

Q: What is dbDeveloper?
A: dbDeveloper is a visual development tool intended for database design, modeling, creation, modification in an easy and powerful way.
It not only accelerates and makes the process of database creation clear but also simplifies database maintenance. dbDeveloper is developed to work with popular databases systems and takes into account theirs features. It gives the user a similar interface to many databases so that there is no need to have many tools each working differently. dbDeveloper makes your work faster and more simply.

Q: Where can I obtain a dbDeveloper?
A: You can always download the latest version of dbDeveloper at its Download Page. The 30-day trial version of dbDeveloper is fully functional.

Q: What is the trial period of dbDeveloper and what functionality limitations does the trial version have?
A: You can use dbDeveloper absolutely free for a period of 30 (thirty) days since the first installation. The trial version of dbDeveloper has no trial functionality limitations so you can evaluate all the possibilities and features of this product.

Q: How can I purchase dbDeveloper?
A: The best way to purchase dbDeveloper is to get online registration through a third party billing service provided by ShareIt. ShareIt also offers you offline ordering options - by phone, mail, fax, wire and PO (if applicable). Please find all the details at the Order Page.

Q: What support is available for dbDeveloper?
A: We provide our customers with efficient and high-professional e-mail support, which is absolutely free. Whether you have any questions about dbDeveloper or you want to report a bug, feel free to do it through the on-line form.

Q: What platform does dbDeveloper run on?
A: dbDeveloper runs on Windows 95/98/Me/2000/NT4/XP and Pentium processor, 32 MB RAM is recommended.

Technical questions

Q: How can I sort using two or more columns?
A: To sort on multiple selected columns hold SHIFT down while clicking column headers to set multiple sorted columns; hold CTRL down and click columns area to remove sorting.

Q: What expressions can be used to filter data id grid?
A: Now for every column you may specify filter statement which is of the form:

[RELATIONAL SIGN] STATEMENT

where relational sign is one of the following =, <>, <, >, <=, >=.
Omitting relational sign has the same effect as using equal sign ('=').
Statement is any alphanumerical text which is of a valid data type allowed for the corresponding field. For fields which accept string values you may specify filter mask in the statement substituting masked characters with an asterisk or percent ('*' or '%') symbol. To substitute a single character use underscore ('_') mask symbol.
Examples:
>20 for Numeric column,
<>T*T2 for String column.

Q: Sometimes specyfying alias or (table name) and dot I should get Completion Proposal with list of table columns. But instead I get a list of tables?
A: That happens when sql parser can't manage with query (it can be not correct, not finished etc.) In that situation parser doesn't know what tables are used in query. So Completion Proposa; doesn't show list of columns but list tables instead.

Q: When I'm in Connect dialog and choose Oracle I got an error "TNS ....". My Oracle configuration is correct because I can connect to server using SQL Plus?
A: It is because you haven't specified proper path to Oracle directory or you have preinstalled Oracle in other directory. dbDeveloper was asking about that path when you run it for the first time. You can set this Oracle home directory path manually in registy key: HKEY_LOCAL_MACHINE\SOFTWARE\ORACLE\ORACLE_HOME.

Q: I connect through ODBC. During calling some queries I got an error: "Invalid descriptor index <13>" A: Some ODBC driver can't execute a query, when BLOB column is not the last column for the query. You need to place BLOB columns at the end of select-item list.

Q: What are minimum required files for connect to MS SQL Server?
A: Below you can view description for the files, which are required for connectivity to Microsoft SQL Server. You can place the required files in Windows system directory (WinNT\system32 or Win95\system) or any other, which is necessary to add to the PATH environment variable.
File Name                         Description
ntwdblib.dll                      DB-Lib interface library contains
                                  functions for the WIN32 API

Communication DLL                 You can use one of the following Net library:
/ Net Library One library         Dbnmpntw.dll - Named Pipes library
for used communication protocol.  Dbmssocn.dll or dbnetlib.dll (for MSSQL 2000)
                                  - TCP/IP Sockets library
                                  Dbmsspxn.dll - NWLink IPX/SPX library
                                  Dbmsrpcn.dll - Multi-Protocol library

If you will use Named Pipes protocol, then it is enough to distribute the following
files with your application: Ntwdblib.dll and Dbnmpntw.dll.
As since Named Pipes is default Net-Library for MS SQL Client,
if Net-Library entry is not exist in registry.

When you need to use other Net Library (except Named Pipes),
then you need to import the following data(Net Library entry)
in the system registry for connect through TCP/IP library (for example):

[HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\MSSQLServer\Client\ConnectTo]
"DSQUERY"="DBMSSOCN"
[HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\MSSQLServer\Client\DB-Lib]
"AutoAnsiToOem"="on"
"UseIntlSettings"="ON"

Q: How I can connect to SQL Anywhere(or Adaptive Server Anywhere)?
A: First, you need to run SQL Anywhere as Open Server. It’s required Open Server Gateway for SQL Anywhere ver.5 and nothing for SQL Anywhere ver.6 (see SQL Anywhere Manuals for command line options). Second, you need to install Open Client Library (see below).

Q: What’s need for Open Client Library deploy?
A: For deploying Open Client libraries you need to copy the following files and directories from full installation:
File/Directory Name            Description
\sybase\dll                    Includes API-interface and communication libraries.
Libcomn.dll                    Open Client and Open Server Common Library
Libcs.dll                      Open Server Library
Libct.dll                      Open Client Library
Libintl.dll                    Locale library
Libtcl.dll                     TLI library
Nlmsnmp.dll                    Named Pipes Driver
Nlwnsck.dll                    WinSock TCP/IP Driver
Nlnwlink.dll                   NWLink IPX/SPX Driver
                               You can use and deploy only one network driver.

\sybase\ini                    Contains initialization files
Libtcl.cfg
Objectid.dat
Sql.ini

\sybase\charsets               Contains all charsets. You can use and copy only required
                               charsets. In most cases, it is enough “Iso_1” and “Utf8”
                               charset directories.
\sybase\locales                Contains messages for some code pages. In most cases,
                               it is enough a “English\Iso_1” locale directory.

Also you need set SYBASE environment variable to a path, which contains Sybase client,
and add drive:\sybase\dll directory to the PATH environment variable.
You can add the following line in your autoexec.bat and change X:\ on your valid driver,
which contains Sybase client.

SET SYBASE=X:\sybase
SET PATH=%PATH%;X:\sybase\dll
Below you can see a content of Sql.ini for TCP/IP connect, where ASESRV is
a SQL Server name, and SRVHOST(port: 5000) is a host with SQL Server.

[ASESRV]
$BASE$00=NLWNSCK,SRVHOST,5000
MASTER=$BASE$00;
$BASE$01=NLWNSCK,SRVHOST,5000
QUERY=$BASE$01;

Q: How can I connect to specified server. What connection string should I put in the "Server name" field?
A:
- DB2, Informix and ODBC:
  The "Server name" field can contain DSN, which is set up in ODBC Administrator,
  or a full datasource string with supported parameters for the required server.
  Below you can see an example of datasource string for Informix server:
  'SERVICE=ids_srv1;HOST=yourhost;PROTOCOL=OLSOCTCP;SERVER=ids_srv1;DATABASE=sysmaster;
  UID=informix;PWD=informix '.

- Interbase:
  The "Server name" field defines a remote server, path to the required database
  and network protocol. See examples below.
  RemoteDatabase value	    Used network protocol
  :	                                TCP
  \\\                                  NetBEUI
  @	                                SPX

- Oracle:
  The property specifies a host string/service name.

- MySQL, MS SQL Server or Sybase SQL Server:
  If you connect to a remote server then "Server name" field has to include server
  and database names divided by colon.
  For example, "srv1:pubs" defines database name PUBS on the server SRV1.


Versions

Version history

    ver 1.95 (29.12.2004)
  • executing and testing procedures and functions etc... (input and output parameters) shortcut: F8
  • Save As... command in SQL Editor
  • Dropping and disabling/enabling table constraints
  • DBMS_OUTPUT catch up during stored procedures testing (Oracle)
    ver 1.94 (22.12.2004)
  • in-grid result data edition (tables window); all data in grid can be changed in grid (Oracle an SQL Server only)
  • connect dialog now stays until user enters right data or clicks Cancel button; earlier it was closed even if the user entered invalid data to connect.
  • "Copy table to clipboard" command that copies all data from grid (tables and sql windows) now shows confirmation dialog before execution
  • some small bugfixes
    ver 1.93 (14.12.2004)
  • query parameters support
  • templates for new procedure, function, etc... - different for each database
  • tablespaces detailed information
  • tables analysis functions (right click on table)
  • sequence, synonyms, DBLink creation (Oracle)
  • sessions window - sql preview in another window
  • locks window now show data on demand
  • bugfix: sessions window now print all user sessions
  • bugfix: disconnect session now works properly
  • bugfix: all environment options are now saved properly
    ver 1.92 (01.12.2004)
  • themed grids
  • removed (unnecessary) ORACLE registry key checking
  • zebra like database grid painting
  • removed nexus theme
    ver 1.91 (20.11.2004)
  • execution plan fix (now working with Oracle's WITH clause)
    ver 1.87 - 1.90
  • table column's comment can be easily changed now
  • constraints icons
  • Interbase constraints are now working
  • sql 'With as' keyword now is working
  • automatic dbgrid columns stretch (can be set in options)
  • Splitter now supports themes
  • new 'Whidbey' theme
  • Tooltip hints (when caption is too logn) in every list and grid.
    ver 1.86
  • Interbase and Firebird support
    ver 1.70-1.85
  • MSSQL execution plan
  • MySQL execution plan
  • MySQL sessions
  • Compile invalid objects and java sources (oracle)
  • SQL execution history
  • Simple SQL format
  • New better grid component (moving columns, sorting, look)
  • New DBGrid component (data filtering, sorting)
  • Export query results to HTML, XML, CVS (comma separated values) and other files
  • Four new interface skins
  • Antyaliased icons
  • F5 works like Ctrl+E (SQL Execute)
    ver 1.70
  • Many new things I don't remember :)
    ver 1.52
  • For Oracle: Java objects and sources, DBLinks, Clusters, Directories, Jobs, Database locks (for sysdba only),
  • Better interface look (office XP look)
  • Sequences, Views
  • Copy DDL to clipboard (create table, insert statements, update statements, select statements)
  • Transactions
  • Show all indexes
  • Show all constraints
  • Every object in database has now additional "details tab"
  • Execution plan for query (Oracle only)
  • In SQL editor - show whitespaces command
  • LRU connections combo in main menu
    ver 1.30
  • Triggers and procedures are now encapsulated in one window called OBJECTS; and extended
  • Possibility to modify and compile functions, procedures, triggers, packages etc. sources
  • Object compilation errors are snow in a bottom panel
  • User can see cursor position in object's editing window
  • Two types of completion proposals are now added to SQL window and object window (Ctrl + Space) and (Ctrl + Shift + Space)
  • Cursor position in SQL window is now updated properly, every time user changes SQL editors
  • SQLEdit background color and font can be set in configuration
  • Tables window is properly refreshed every time user adds, removes,... a column
  • "Results to clipboard" is added to a tables' window
  • In a connection's window last connections are now sorted properly
    ver 1.25
  • Constraints, dependencies and other information for table is now accessible (Oracle)
    ver 1.20
  • SQL editor can manage multiple open files, the user can switch between
  • Some minor bug fixes
    ver 1.11
  • Multiple sql statements can be executed in one transaction
  • Some minor bug fixes

    ver 1.10
  • Windows XP style look

    ver 1.09
  • Configuration is working


License

License Agreement

dbDeveloper License Agreement
====================================

NO WARRANTY
-----------
DBDEVELOPER IS SOLD "AS IS" AND WITHOUT ANY WARRANTY AS TO
MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE OR ANY
OTHER WARRANTIES EITHER EXPRESSED OR IMPLIED. THE AUTHOR WILL
NOT BE LIABLE FOR DATA LOSS, DAMAGES, LOSS OF PROFITS OR ANY
OTHER KIND OF LOSS WHILE USING OR MISUSING THIS SOFTWARE.

Evaluation and Registration
---------------------------
dbDeveloper is not free software. You may use this software for
evaluation purposes without charge for a period of 30 days. At
the end of the trial period, you must either pay registration fee
or remove the software from your system.

Distribution of the evaluation version
--------------------------------------
You may copy the evaluation version of this software and
documentation as you wish, and give exact copies of the
original evaluation version to anyone, and distribute the
evaluation version of the software and documentation in its
unmodified form via electronic means. But you should not
charge or requesting donations for any such copies however
made and from distributing the software and/or documentation
with other products without the author's written permission.

Registered version
------------------
One registered copy of dbDeveloper may either be used by a single
person who uses the software personally on one or more
computers, or installed on a single workstation used
non-simultaneously by multiple people, but not both. You may
access the registered version of dbDeveloper through a network,
provided that you have obtained individual licenses for the
software covering all workstations that will access the
software through the network.

Acceptance of this License Agreement
------------------------------------
By downloading and/or installing this software, the user agrees
to the terms of this License.


Information

Authors

The autor of dbDeveloper is Radoslaw Pujan
Homepage: www.prominentus.com
Email: bagieta@prominentus.com

Contributors

Special thanks to:
(SynEdit): synedit.sourceforge.net
Mike Lischke (Virtual Treeview): www.soft-gems.net
Jordan Russell (Toolbar 2000): www.jrsoftware.org
Alex Denisov (TBX): www.g32.org
Roy M Klever (Themes): www.rmklever.com
Gustavo Daud (PNGImage): pngdelphi.sourceforge.net
Yuri Sheino (SQLDirect): www.sql-direct.com
Gert Kello (ga SQL parser): gasqlparser.sourceforge.net